<?php
/* -------------------------------------------
 * MobileCMS
 * ------------------------------------------- */
class ContentsController extends AppController {

	var $name = 'Contents';
	var $components = array('context','RequestHandler','rss','contentelement');
	var $uses = array('Content');
	var $helpers = array('Html','Text','Time','Form','Ajax','Javascript','Fck','Zarame','Mobilepict');

	function admin_index() {
		$contents = $this->Content->findAll('','','cid ASC');
		if (!empty($contents)) {
			$this->set('content_pages', $contents);
		} else {
			$this->redirect('/admin/contents/add');
		}
	}

	function admin_add() {
		$this->set('contentlists', $this->Content->findAll('','','cid ASC'));
		if (!empty($this->data)) {
			$this->data['Content']['content'] = str_replace(array("\r\n", "\r", "\n"), "", $this->data['Content']['content']);
			$this->data['Content']['content'] = $this->contentelement->noContent($this->data['Content']['content']);

			if ($this->data['Content']['url'] == "") {
				$this->data['Content']['url'] = urlencode($this->data['Content']['title']);
			}

			if ($this->Content->save($this->data)) {
				$content_page_id = $this->Content->getLastInsertId();
				$this->data['Content']['cid'] = $content_page_id;
				$this->Content->save($this->data);
				$this->redirect('/admin/contents/');
			}
		}
	}

	function admin_edit($id = null) {
		if (empty($this->data)) {
			$this->Content->id = $id;
			$this->data = $this->Content->read();

			$this->set('contentlists', $this->Content->findAll('','','cid ASC'));
			$this->data['Content']['content'] = $this->contentelement->imgContent($this->data['Content']['content']);
			$this->set('content_page', $this->data);
		} else {
			$this->data['Content']['content'] = str_replace(array("\r\n", "\r", "\n"), "", $this->data['Content']['content']);

			$this->data['Content']['content'] = $this->contentelement->noContent($this->data['Content']['content']);
			if ($this->data['Content']['cid'] == 0 || $this->data['Content']['cid'] == "") {
				$this->data['Content']['cid'] = $this->data['Content']['id'];
			}
			if ($this->data['Content']['url'] == "") {
				$this->data['Content']['url'] = urlencode($this->data['Content']['title']);
			}

			if ($this->Content->save($this->data['Content'])) {
				$this->redirect('/admin/contents/');
			}
		}
	}

	function admin_delete($id = null) {
		if (empty($this->data)) {
			$this->Content->id = $id;
			$this->data = $this->Content->read();
			$this->set('content_page', $this->Content->read());
		} else {
			//$this->Content->MenuItem->del($this->data['MenuItem']['id']);
			$this->Content->del($this->data['Content']['id']);
			$this->redirect('/admin/contents/');
		}
	}

	function admin_swap($from, $to) {
		$this->context->method='index';

		$fromContent = $this->Content->findByCid($from);
		$toContent = $this->Content->findByCid($to);

		$this->data = $fromContent;
		$this->data['Content']['cid'] = $toContent['Content']['cid'];
		//$this->data['Content']['level'] = $toContent['Content']['level'];
		$this->Content->save($this->data['Content']);

		$this->data = $toContent;
		$this->data['Content']['cid'] = $fromContent['Content']['cid'];
		//$this->data['Content']['level'] = $fromContent['Content']['level'];
		$this->Content->save($this->data['Content']);

		$this->layout="blank";
		$this->set('content_pages', $this->Content->findAll('','','cid ASC'));
	}

/*
	function admin_levelin($id) {
		$this->context->method='index';

		$this->data = $this->Content->findById($id);
		$this->data['Content']['level'] += 1;
		$this->Content->save($this->data['Content']); 

		$this->layout="blank";
		$this->set('content_pages', $this->Content->findAll('','','cid ASC'));
	}
*/
/*
	function admin_levelout($id) {
		$this->context->method='index';

		$this->data = $this->Content->findById($id);
		$this->data['Content']['level'] -= 1;
		$this->Content->save($this->data['Content']);

		$this->layout="blank";
		$this->set('content_pages', $this->Content->findAll('','','cid ASC'));
	}
*/

	function view($url) {
		$url = urlencode($url);
		$this->data = $this->Content->findByUrl($url);
		$this->data['Content']['content'] = $this->contentelement->fetchContent($this->data['Content']['content']);
		$configdata = $this->requestAction('/configs/getConfig');
		$this->set('config', array_to_encoding($configdata, 'UTF-8', 'SJIS'));
		$this->pageTitle = utf2sjis($this->data['Content']['title']."-".$configdata['Config']['sitetitle']);
		$this->set('display', array_to_encoding($this->data, 'UTF-8', 'SJIS-win'));
	}

	function viewid($id) {
		$this->Content->id = $id;
		$this->data = $this->Content->read();
		$this->data['Content']['content'] = $this->contentelement->fetchContent($this->data['Content']['content'],'id');
		$configdata = $this->requestAction('/configs/getConfig');
		$this->set('config', array_to_encoding($configdata, 'UTF-8', 'SJIS'));
		$this->pageTitle = utf2sjis($this->data['Content']['title']."-".$configdata['Config']['sitetitle']);
		$this->set('display', array_to_encoding($this->data, 'UTF-8', 'SJIS-win'));
	}

}
?>
