<?php
/* -------------------------------------------
 * MobileCMS
 * ------------------------------------------- */
uses('model' . DS . 'connection_manager');
class InstallController extends AppController {
	var $autoRender = false;
	var $uses = array();

	function beforeFilter() {
		$this->components = array();
		if (file_exists(TMP.'installed.txt')) {
			echo 'インストール済みです。再インストールする場合は[ /cake/app/tmp/installed.txt ]を削除してください';
			exit();
		}
	}


	function afterFilter() {}


	function index() {
		$this->layout = "install";
		$this->step1();
	}

/* ------------------------------------------
 * 1. database.phpとパーミッションをチェック
 * 2. database.phpを作成
 * 3. サイト設定、管理者ユーザーを作成しインストール終了
 * ------------------------------------------ */
	function step1() {
		$this->layout = "install";
		if ($this->__dbFileExists()) {
			$this->render(null,null,'views/install/db_error.thtml');
			exit;
		}
		if($this->__testFileSystem()) {
			$this->redirect('install/step2');
			exit;
		}
	}


	function step2() {
		$this->layout = "install";
		if (!$this->__dbFileExists()) {
			$this->errors = '';
			if($this->__createDatabase()) {
				$this->redirect('install/step3');
			}
		}
		$this->render(null,null,'views/install/db_error.thtml');
	}


	function step3() {
		$this->layout = "install";
		if ($this->__createUser()) {
			file_put_contents(TMP.'installed.txt', date('Y-m-d, H:i:s'));
			$this->render(null, null, 'views/install/success.thtml');
			exit;
		}
	}


	function __createUser() {
		$this->errors= '';
		@ $values['sitetitle']= ($_POST['sitetitle']) ? $_POST['sitetitle'] : '';
		@ $values['siteurl']= ($_POST['siteurl']) ? $_POST['siteurl'] : '';
		@ $values['metadescription']= ($_POST['metadescription']) ? $_POST['metadescription'] : '';
		@ $values['metakeywords']= ($_POST['metakeywords']) ? $_POST['metakeywords'] : '';

		if (isset ($_POST['sitetitle']) && !empty ($_POST)) {
			if (trim($_POST['sitetitle'] == '')) {
				$this->errors= "サイト名を入力してください。<br /><br />";
			} elseif (trim($_POST['siteurl'] == '')) {
				$this->errors= "サイトURLを入力してください。<br /><br />";
			}
		}

		@ $values['username']= ($_POST['username']) ? $_POST['username'] : '';
		@ $values['password']= ($_POST['password']) ? $_POST['password'] : '';
		@ $values['name']= ($_POST['name']) ? $_POST['name'] : '';
		@ $values['email']= ($_POST['email']) ? $_POST['email'] : '';

		if (isset ($_POST['username']) && !empty ($_POST)) {
			if (trim($_POST['username'] == '' || $_POST['password'] == '')) {
				$this->errors= "ユーザー名とパスワードを入力してください。<br /><br />";
			} elseif (trim($_POST['email']) == '') {
				$this->errors .= "メールアドレスを入力してください。";
			} elseif (!preg_match('/^([_a-zA-Z0-9.]+@[-a-zA-Z0-9]+(\.[-a-zA-Z0-9]+)+)*$/', $_POST['email'])) {
				$this->errors .= "メールアドレスが不正です。";
			} else {
				$this->__createTables();
				return true;
				exit;
			}
		}

		$this->set('values', $values);
		$this->set('errors', $this->errors);
		$this->set(array (
			'title' => 'Install MobileCMS'
		));
		$this->layout = "install";
		$this->render(null, null, 'views/install/admin.thtml');
		exit;
	}


	function __createDatabase() {
		@ $values['dbserver']= ($_POST['dbserver']) ? $_POST['dbserver'] : 'localhost';
		@ $values['dbname']= ($_POST['dbname']) ? $_POST['dbname'] : '';
		@ $values['dbuser']= ($_POST['dbuser']) ? $_POST['dbuser'] : '';
		@ $values['dbpass']= ($_POST['dbpass']) ? $_POST['dbpass'] : '';
		@ $values['table_prefix']= ($_POST['table_prefix']) ? $_POST['table_prefix'] : 'MCMS_';

		if (isset ($_POST) && !empty ($_POST)) {
			$this->errors= '';
			$this->__testSqlConnection();
			if ($this->errors == '') {
				$this->__createDatabaseConfigFile();
				if ($this->errors == '') {
					return true;
				}
			}
		}

		$this->set('values', $values);
		$this->set('errors', $this->errors);
		$this->set(array (
			'title' => 'Install MobileCMS'
		));
		$this->layout = "install";
		$this->render(null, null, 'views/install/database.thtml');
		exit;
	}


	function __testFileSystem() {
		$this->layout = "install";
		$configDir= ROOT . '/app/config/';
		$tmpDir= ROOT . '/app/tmp/';
		$filesDir= WWW_ROOT . 'files';
		$writableDirs= array (
			$configDir,
			$tmpDir,
			$filesDir
		);
		$areNotWriteable= array ();

		foreach ($writableDirs as $dir) {
			if (!is_writable($dir)) {
				$areNotWriteable[]= $dir;
			}
		}
		if (count($areNotWriteable)) {
			$this->set('areNotWriteable', $areNotWriteable);
			$this->set(array (
				'title' => 'Install MobileCMS'
			));
			$this->render(null, null, 'views/install/fileSystem.thtml');
			exit;
		}
		return true;
	}


	function __dbFileExists() {
		$db_file = ROOT.'/app/config/database.php';
		if (file_exists($db_file)) {
			return true;
		}
		return false;
	}


	function __testSqlConnection() {
		if (isset ($_POST) && !empty ($_POST)) {
			if (!function_exists('mysql_connect')) {
				$this->errors .= "PHP does not have MySQL support enabled.";
			} elseif (!$connect_id= @ mysql_connect($_POST['dbserver'], $_POST['dbuser'], $_POST['dbpass'])) {
				$this->errors .= "Could not create a mySQL connection, please check the values entered<br />MySQL error was : " . mysql_error() . "<br /><br />";
			} elseif (!mysql_select_db($_POST['dbname'], $connect_id)) {
				$this->errors .= "MySQL database called '{$_POST['dbname']}' could not be connected using the details provided, please check the values entered for these are correct";
			}
		}
	}


	function __createDatabaseConfigFile() {
		$db_file= ROOT . '/app/config/database.php';
		$config_file= '/app/config/database.php';
		@ unlink($db_file);
		$config= $this->__buildCfgFile();
		if ($fd= @ fopen($db_file, 'wb')) {
			fwrite($fd, $config);
			fclose($fd);
		} else {
			$this->errors .= "<hr /><br />Unable to write config file '{$config_file}'<br /><br />";
		}
	}


	// ---------------------- CONFIGURATION FILE TEMPLATE ---------------------- //
	function __buildCfgFile() {
return<<<EOT
<?php
class DATABASE_CONFIG
{
	 var \$default = array(
						'driver' => 'mysql',
						'connect' => 'mysql_connect',
						'host' => '{$_POST['dbserver']}',
						'login' => '{$_POST['dbuser']}',
						'password' => '{$_POST['dbpass']}',
						'database' => '{$_POST['dbname']}',
						'prefix' => '{$_POST['table_prefix']}',
						'encoding' => 'utf8'
					);
}
?>
EOT;
	}


	function __createTables() {
		loadModel('ConnectionManager');
		$db= & ConnectionManager :: getDataSource('default');

		$prefix= $db->config['prefix'];
		$sqlFile= ROOT . DS . APP_DIR . DS . 'sql/mcms.sql';

		$sql= file_get_contents($sqlFile);

		// Site
		$sql .= "INSERT INTO `MCMS_configs` (`id`, `sitetitle`, `siteurl`, `metadescription`, `metakeywords`, `email`, `bgcolor`, `textcolor`, `linkcolor`, `alinkcolor`, `vlinkcolor`, `created`, `modified`) VALUES (1,'{$_POST['sitetitle']}','{$_POST['siteurl']}','{$_POST['metadescription']}','{$_POST['metakeywords']}','{$_POST['email']}','#FFFFFF','','#0000FF','#FF6600','#FF33CC',now(),now());";

		// User
		$passwd = md5($_POST['password']);
		$sql .= "INSERT INTO `MCMS_users` (`id`, `username`, `password`, `group_id`, `active`, `created`, `modified`) VALUES (1,'{$_POST['username']}','{$passwd}',2,1,now(),now());";

		// Group
		$sql .= "INSERT INTO `MCMS_groups` (`id`, `name`, `created`, `modified`) VALUES (1,'Member',now(),now());";
		$sql .= "INSERT INTO `MCMS_groups` (`id`, `name`, `created`, `modified`) VALUES (2,'Admin',now(),now());";

		// Content
		$sql .= "INSERT INTO `MCMS_contents` (`id`, `cid`, `title`, `url`, `metadescription`, `metakeywords`, `content`, `level`, `published`, `created`, `modified`) VALUES (1, 1, 'Home', 'Home', '', '', 'HOME', 0, 0, now(), now());";

		$sql_query= preg_replace('/MCMS_/', $prefix, $sql);

		$sql_query= $this->__removeRemarks($sql_query);
		$sql_query= $this->__splitSqlFile($sql_query, ';');

		foreach ($sql_query as $q) {
			$db->query($q);
		}
	}


	// __removeRemarks will strip the sql comment lines out of an uploaded sql file
	//Adapted this function from the - Coppermine Picture Gallery http://coppermine.sf.net
	function __removeRemarks($sql) {
		$lines = explode("\n", $sql);
		// try to keep mem. use down
		$sql= "";

		$linecount = count($lines);
		$output= "";

		for ($i= 0; $i < $linecount; $i++) {
			if (($i != ($linecount -1)) || (strlen($lines[$i]) > 0)) {
				if (isset ($lines[$i][0]) && $lines[$i][0] != "#") {
					$output .= $lines[$i] . "\n";
				} else {
					$output .= "\n";
				}
				// Trading a bit of speed for lower mem. use here.
				$lines[$i]= "";
			}
		}

		return $output;
	}


	// __splitSqlFile will split an uploaded sql file into single sql statements.
	// Note: expects trim() to have already been run on $sql.
	//Adapted this function from the - Coppermine Picture Gallery http://coppermine.sf.net
	function __splitSqlFile($sql, $delimiter) {
		// Split up our string into "possible" SQL statements.
		$tokens= explode($delimiter, $sql);
		// try to save mem.
		$sql= "";
		$output= array ();
		// we don't actually care about the matches preg gives us.
		$matches= array ();
		// this is faster than calling count($oktens) every time thru the loop.
		$token_count= count($tokens);
		for ($i= 0; $i < $token_count; $i++) {
			// Don't wanna add an empty string as the last thing in the array.
			if (($i != ($token_count -1)) || (strlen($tokens[$i] > 0))) {
				// This is the total number of single quotes in the token.
				$total_quotes= preg_match_all("/'/", $tokens[$i], $matches);
				// Counts single quotes that are preceded by an odd number of backslashes,
				// which means they're escaped quotes.
				$escaped_quotes= preg_match_all("/(?<!\\\\)(\\\\\\\\)*\\\\'/", $tokens[$i], $matches);

				$unescaped_quotes= $total_quotes - $escaped_quotes;
				// If the number of unescaped quotes is even, then the delimiter did NOT occur inside a string literal.
				if (($unescaped_quotes % 2) == 0) {
					// It's a complete sql statement.
					$output[]= $tokens[$i];
					// save memory.
					$tokens[$i]= "";
				} else {
					// incomplete sql statement. keep adding tokens until we have a complete one.
					// $temp will hold what we have so far.
					$temp= $tokens[$i] . $delimiter;
					// save memory..
					$tokens[$i]= "";
					// Do we have a complete statement yet?
					$complete_stmt= false;

					for ($j= $i +1;(!$complete_stmt && ($j < $token_count)); $j++) {
						// This is the total number of single quotes in the token.
						$total_quotes= preg_match_all("/'/", $tokens[$j], $matches);
						// Counts single quotes that are preceded by an odd number of backslashes,
						// which means they're escaped quotes.
						$escaped_quotes= preg_match_all("/(?<!\\\\)(\\\\\\\\)*\\\\'/", $tokens[$j], $matches);

						$unescaped_quotes= $total_quotes - $escaped_quotes;

						if (($unescaped_quotes % 2) == 1) {
							// odd number of unescaped quotes. In combination with the previous incomplete
							// statement(s), we now have a complete statement. (2 odds always make an even)
							$output[]= $temp . $tokens[$j];
							// save memory.
							$tokens[$j]= "";
							$temp= "";
							// exit the loop.
							$complete_stmt= true;
							// make sure the outer loop continues at the right point.
							$i= $j;
						} else {
							// even number of unescaped quotes. We still don't have a complete statement.
							// (1 odd and 1 even always make an odd)
							$temp .= $tokens[$j] . $delimiter;
							// save memory.
							$tokens[$j]= "";
						}
					} // for..
				} // else
			}
		}
		return $output;
	}
}

?>