<?php
class GooglemapController extends GooglemapAppController {

	var $name = 'Googlemap';
	var $uses = array('Googlemap');
	var $components = array('context');
	var $autoRender = false;
	var $helpers = array ('Html','Javascript','Zarame');


	function map() {
		if (isset($this->params['data'])) {
			$lat = $this->params['data']['map']['lat'];
			$lon = $this->params['data']['map']['lon'];
			$zm = $this->params['data']['map']['zm'];
			$cx = $this->params['data']['map']['cx'];
			$cy = $this->params['data']['map']['cy'];
			$vx = $this->params['data']['map']['vx'];
			$vy = $this->params['data']['map']['vy'];
		} else {
			$lat = $this->params['url']['lat'];
			$lon = $this->params['url']['lon'];
			$zm = $this->params['url']['zm'];
			$cx = $this->params['url']['cx'];
			$cy = $this->params['url']['cy'];
			$vx = $this->params['url']['vx'];
			$vy = $this->params['url']['vy'];
		}

		$mapdata = $this->Googlemap->findById($this->Googlemap->id='1');
		if($mapdata){
			$this->data['MapApiID'] = $mapdata['Googlemap']['apikey'];

			// マーカー座標
			if ($lat) { $this->data['lat'] = $lat; } else { $this->data['lat'] = $mapdata['Googlemap']['lat']; }
			if ($lon) { $this->data['lon'] = $lon; } else { $this->data['lon'] = $mapdata['Googlemap']['lon']; }

			$configdata = $this->requestAction('/configs/getConfig');
			$this->set('config', array_to_encoding($configdata, 'UTF-8', 'SJIS'));
			$this->pageTitle = utf2sjis("地図-".$configdata['Config']['sitetitle']);

			// センター座標
			if ($cx == "") { $this->data['cx'] = $mapdata['Googlemap']['lat']; } else { $this->data['cx'] = $vx; }
			if ($cy == "") { $this->data['cy'] = $mapdata['Googlemap']['lon']; } else { $this->data['cy'] = $vy; }

			// 表示センター座標
			if ($vx == "") { $vx = $mapdata['Googlemap']['lat']; }
			if ($vy == "") { $vy = $mapdata['Googlemap']['lon']; }
			$this->data['vx'] = $vx;
			$this->data['vy'] = $vy;

			// デフォルトズーム度
			if ($zm == "") { $zm = 15; }
			$this->data['zm'] = $zm;

			// 移動先座標
			$ZmLv = array("18"=>100, "17"=>300, "16"=>600, "15"=>1000, "14"=>2000, "13"=>3500, "12"=>7000, "11"=>14000, "10"=>30000, "9"=>70000);
			$this->data['right'] = $vy + (0.000003 * $ZmLv[$zm]);
			$this->data['left']  = $vy - (0.000003 * $ZmLv[$zm]);
			$this->data['up']    = $vx + (0.000003 * $ZmLv[$zm]);
			$this->data['down']  = $vx - (0.000003 * $ZmLv[$zm]);

			$this->set('map', array_to_encoding($this->data, 'UTF-8', 'SJIS-win'));
			$this->render(null,null,'plugins/googlemap/views/googlemap/map.thtml');
		}
	}


	function admin_install() {
		echo 'true';
	}


	function admin_uninstall() {
		echo 'true';
	}


	function admin_managerGui() {
		$configdata = $this->requestAction('/configs/getConfig');
		$this->set('config', array_to_encoding($configdata, 'UTF-8', 'SJIS'));

		if (isset($this->data)) {
			$this->data['Googlemap']['id'] = 1;
			if ($this->Googlemap->save($this->data)) {
				$this->Session->setFlash("Data for 'GoogleMap' addon has been saved successfully",'default',array(),'success');
				$this->redirect('/admin/addons');
				exit;
			}
		} else {
			$this->Googlemap->id = 1;
			$this->data = $this->Googlemap->read();
		}
		$this->render();
	}

}
?>
