<?php
require_once 'common.php';

// {{{ class MPC_EZweb
/**
* EZwebGϊx[XNX
* 
* @author   ryster <ryster@php-develop.org>
* @license  http://www.opensource.org/licenses/lgpl-license.php The LGPL License
* @link     http://php-develop.org/MobilePictogramConverter/
*/
class MPC_EZweb extends MPC_Common
{
    /**
    * GoK\
    * @var string
    */
    var $regex = array(
        'WEB' => '/<img\s+(icon|localsrc)="?([0-9]+)"?\s*>/ie',
        'IMG' => '/(<img src="{PATH}\/(\d{1,3})\.gif" alt="" border="0" \/>)/ie',
    );
    
    /**
    * 񂩂EZwebGoAw肳ꂽtH[}bgɕϊ
    * {EgEBGΉ
    * 
    * @param string  $to     (MPC_TO_FOMA, MPC_TO_EZWEB, MPC_TO_SOFTBANK)
    * @param integer $option (MPC_TO_OPTION_RAW, MPC_TO_OPTION_WEB, MPC_TO_OPTION_IMG)
    * @return string
    */
    function Convert($to, $option = MPC_TO_OPTION_RAW)
    {
        $buf = '';
        $this->setTo($to);
        $this->setOption($option);
        $str     = $this->getString();
        $type    = $this->getStringType();
        $charset = $this->getFromCharset();
        $plus    = ($charset == MPC_FROM_CHARSET_UTF8) ? 2 : 1;
        
        if ($type != MPC_FROM_OPTION_RAW) {
            if (empty($this->e2icon_table)) {
                require 'map/e2icon_table.php';
            }
            $regex = str_replace('{PATH}', preg_quote(rtrim($this->getEZwebImagePath(), '/'), '/'), $this->getRegex($type));
            $eval  = ($charset == MPC_FROM_CHARSET_UTF8) ? 'mb_convert_encoding(pack("H*", dechex(\$this->e2icon_table[$2] - 1792)), "UTF-8", "unicode")' : 'pack("H*", dechex(\$this->e2icon_table[$2]))';
            $str   = preg_replace($regex, $eval, $str);
        }
        
        $str = unpack('C*', $str);
        for ($i = 1;$i <= count($str);$i++) {
            $binarys = array();
            $binarys[] = $char1 = $str[$i];
            if (isset($str[$i + 1])) {
                $binarys[] = $char2 = $str[$i + 1];
            }
            if ($charset == MPC_FROM_CHARSET_UTF8 && isset($str[$i + 2])) {
                $binarys[] = $char3 = $str[$i + 2];
            }
            
            if ($this->isPictogram($binarys)) {
                $hex = ($charset == MPC_FROM_CHARSET_UTF8) ? strtoupper(dechex(hexdec(bin2hex(mb_convert_encoding(pack('C*', $char1, $char2, $char3), 'unicode', 'utf-8'))) + 1792)) : $this->decs2hex($binarys);
                if (empty($this->e2icon_table)) {
                    require 'map/e2icon_table.php';
                }
                list($iconno) = array_keys($this->e2icon_table, hexdec($hex));
                $buf .= $this->encoder($iconno);
                $i += $plus;
            } elseif ((($char1 >= 0x81 && $char1 <= 0x9F) || ($char1 >= 0xE0 && $char1 <= 0xFC)) && $charset == MPC_FROM_CHARSET_SJIS) {
                $buf .= pack('C*', $char1, $char2);
                $i++;
            } else {
                $buf .= pack('C', $char1);
            }
        }
        return $buf;
    }
    
    /**
    * 񂩂EZwebGO
    * 
    * @return string
    */
    function Except()
    {
        $buf     = '';
        $str     = $this->getString();
        $type    = $this->getStringType();
        $charset = $this->getFromCharset();
        $plus    = ($charset == 'UTF-8') ? 2 : 1;
        
        if ($type != MPC_FROM_OPTION_RAW) {
            if (empty($this->e2icon_table)) {
                require 'map/e2icon_table.php';
            }
            $regex = str_replace('{PATH}', preg_quote(rtrim($this->getEZwebImagePath(), '/'), '/'), $this->getRegex($type));
            return preg_replace($regex, '', $str);
        }
        
        $str = unpack('C*', $str);
        for ($i = 1;$i <= count($str);$i++) {
            $binarys = array();
            $binarys[] = $char1 = $str[$i];
            if (isset($str[$i + 1])) {
                $binarys[] = $char2 = $str[$i + 1];
            }
            if ($charset == MPC_FROM_CHARSET_UTF8 && isset($str[$i + 2])) {
                $binarys[] = $char3 = $str[$i + 2];
            }
            
            if ($this->isPictogram($binarys)) {
                $i += $plus;
            } elseif ((($char1 >= 0x81 && $char1 <= 0x9F) || ($char1 >= 0xE0 && $char1 <= 0xFC)) && $charset == 'SJIS') {
                $buf .= pack("C*", $char1, $char2);
                $i++;
            } else {
                $buf .= pack('C', $char1);
            }
        }
        return $buf;
    }
    
    /**
    * EZwebG܂܂Ă邩`FbN
    *
    * @return integer
    */
    function Count()
    {
        $count   = 0;
        $str     = $this->getString();
        $type    = $this->getStringType();
        $charset = $this->getFromCharset();
        $plus    = ($charset == 'UTF-8') ? 2 : 1;
        
        if ($type != MPC_FROM_OPTION_RAW) {
            $regex = str_replace('{PATH}', preg_quote(rtrim($this->getEZwebImagePath(), '/'), '/'), $this->getRegex($type));
            return preg_match_all($regex, $str, $r);
        }
        
        $str = unpack('C*', $str);
        for ($i = 1;$i <= count($str);$i++) {
            $binarys = array();
            $binarys[] = $char1 = $str[$i];
            if (isset($str[$i + 1])) {
                $binarys[] = $char2 = $str[$i + 1];
            }
            if ($charset == MPC_FROM_CHARSET_UTF8 && isset($str[$i + 2])) {
                $binarys[] = $char3 = $str[$i + 2];
            }
            
            if ($this->isPictogram($binarys)) {
                $count++;
                $i += $plus;
            } elseif ((($char1 >= 0x81 && $char1 <= 0x9F) || ($char1 >= 0xE0 && $char1 <= 0xFC)) && $charset == 'SJIS') {
                $i++;
            }
        }
        return $count;
    }
    
    /**
    * oCiEZwebGǂA`FbN
    * 
    * @param array $chars
    * @return boolean
    */
    function isPictogram($chars)
    {
        if ($this->getFromCharset() == "UTF-8") {
            if (count($chars) != 3){
                return false;
            }
            list($char1, $char2, $char3) = $chars;
            if (
                ($char1 == 0xEE &&
                    (
                        ($char2 == 0xB1 && ($char3 >= 0x80 && $char3 <= 0xBE)) ||
                        ($char2 == 0xB2 && ($char3 >= 0x80 && $char3 <= 0xBF)) ||
                        ($char2 == 0xB3 && ($char3 >= 0x80 && $char3 <= 0xBC)) ||
                        ($char2 == 0xB5 && ($char3 >= 0x80 && $char3 <= 0xBE)) ||
                        ($char2 == 0xB6 && ($char3 >= 0x80 && $char3 <= 0x8D)) ||
                        ($char2 == 0xBD && ($char3 >= 0x80 && $char3 <= 0xBE)) ||
                        ($char2 == 0xBE && ($char3 >= 0x80 && $char3 <= 0xBF)) ||
                        ($char2 == 0xBF && ($char3 >= 0x80 && $char3 <= 0xBC))
                     )
                ) ||
                ($char1 == 0xEF &&
                    (
                        ($char2 == 0x81 && ($char3 >= 0x80 && $char3 <= 0xBE)) ||
                        ($char2 == 0x82 && ($char3 >= 0x80 && $char3 <= 0xBF)) ||
                        ($char2 == 0x83 && ($char3 >= 0x80 && $char3 <= 0xBC))
                    )
                )
            ) {
                $boolean = true;
            } else {
                $boolean = false;
            }
        } else {
            if (count($chars) != 2) {
                return false;
            }
            list($char1, $char2) = $chars;
            if ((($char1 == 0xF3 || $char1 == 0xF6 || $char1 == 0xF7) && (($char2 >= 0x40 && $char2 <= 0x7E) || ($char2 >= 0x80 && $char2 <= 0xFC))) || ($char1 == 0xF4 && (($char2 >= 0x40 && $char2 <= 0x7E) || ($char2 >= 0x80 && $char2 <= 0x8D)))) {
                $boolean = true;
            } else {
                $boolean = false;
            }
        }
        return $boolean;
    }
}
// }}}
?>