<?php
require_once 'common.php';

// {{{ class MPC_FOMA
/**
* FOMAGϊx[XNX
* 
* @author   ryster <ryster@php-develop.org>
* @license  http://www.opensource.org/licenses/lgpl-license.php The LGPL License
* @link     http://php-develop.org/MobilePictogramConverter/
*/
class MPC_FOMA extends MPC_Common
{
    /**
    * GoK\
    * @var string
    */
    var $regex = array(
        'WEB' => '/&#(63\d{3});/ie',
        'IMG' => '/<img *src="{PATH}\/(63\d{3})\.gif" alt="" border="0" width="12" height="12" \/>/ie',
    );
    
    /**
    * 񂩂i-modeGoAw肳ꂽtH[}bgɕϊ
    * {EgEBGꕔΉ
    * 
    * @param string  $to     (MPC_TO_FOMA, MPC_TO_EZWEB, MPC_TO_SOFTBANK)
    * @param integer $option (MPC_TO_OPTION_RAW, MPC_TO_OPTION_WEB, MPC_TO_OPTION_IMG)
    * @return string
    */
    function Convert($to, $option = MPC_TO_OPTION_RAW)
    {
        $buf = '';
        $this->setTo($to);
        $this->setOption($option);
        $str     = $this->getString();
        $type    = $this->getStringType();
        $charset = $this->getFromCharset();
        $plus    = ($charset == MPC_FROM_CHARSET_UTF8) ? 2 : 1;
        
        if ($type != MPC_FROM_OPTION_RAW) {
            if ($type == MPC_FROM_OPTION_WEB) {
                $eval = ($charset == MPC_FROM_CHARSET_UTF8) ? 'mb_convert_encoding(pack("H*", @$1), "UTF-8", "unicode")' : 'mb_convert_encoding(pack("H*", @$1), "SJIS-win", "unicode")';
                $str  = preg_replace('/&#x([a-z0-9]{4});/ie', $eval, $str);
            }
            $regex = str_replace('{PATH}', preg_quote(rtrim($this->getFOMAImagePath(), '/'), '/'), $this->getRegex($type));
            //$eval  = ($charset == MPC_FROM_CHARSET_UTF8) ? 'mb_convert_encoding(pack("H*", dechex($1)), "UTF-8", "SJIS-win")' : 'pack("H*", dechex(\$this->e2icon_table[$2]))';
            $eval  = ($charset == MPC_FROM_CHARSET_UTF8) ? 'mb_convert_encoding(pack("H*", dechex($1)), "UTF-8", "SJIS-win")' : 'pack("H*", dechex($1))';
            $str   = preg_replace($regex, $eval, $str);
        }
        
        $str = unpack('C*', $str);
        for ($i = 1;$i <= count($str);$i++) {
            $binarys = array();
            $binarys[] = $char1 = $str[$i];
            if (isset($str[$i + 1])) {
                $binarys[] = $char2 = $str[$i + 1];
            }
            
            if ($charset == MPC_FROM_CHARSET_UTF8 && isset($str[$i + 2])) {
                $binarys[] = $char3 = $str[$i + 2];
            }
            
            if ($this->isPictogram($binarys)) {
                $decs = ($charset == MPC_FROM_CHARSET_UTF8) ? unpack('C*', mb_convert_encoding(pack('C*', $char1, $char2, $char3), 'SJIS-win', 'UTF-8')) : $binarys;
                $dec  = hexdec($this->decs2hex($decs));
                $buf .= $this->encoder($dec);
                $i += $plus;
            } elseif ((($char1 >= 0x81 && $char1 <= 0x9F) || ($char1 >= 0xE0 && $char1 <= 0xFC)) && $charset == MPC_FROM_CHARSET_SJIS) {
                $buf .= ($to == MPC_TO_SOFTBANK && $option == MPC_TO_OPTION_RAW) ? mb_convert_encoding(pack('C*', $char1, $char2), 'UTF-8', 'SJIS-win') : pack('C*', $char1, $char2);
                $i++;
            } else {
                $buf .= pack('C', $char1);
            }
        }
        return $buf;
    }
    
    /**
    * 񂩂i-modeGO
    * 
    * @return string
    */
    function Except()
    {
        $buf = '';
        $str     = $this->getString();
        $type    = $this->getStringType();
        $charset = $this->getFromCharset();
        $plus    = ($charset == MPC_FROM_CHARSET_UTF8) ? 2 : 1;
        
        if ($type != MPC_FROM_OPTION_RAW) {
            if ($type == MPC_FROM_OPTION_WEB) {
                $str = preg_replace('/&#x([a-z0-9]{4});/ie', '', $str);
            }
            $regex = str_replace('{PATH}', preg_quote(rtrim($this->getFOMAImagePath(), '/'), '/'), $this->getRegex($type));
            return preg_replace($regex, '', $str);
        }
        
        $str = unpack('C*', $str);
        for ($i = 1;$i <= count($str);$i++) {
            $binarys = array();
            $binarys[] = $char1 = $str[$i];
            if (isset($str[$i + 1])) {
                $binarys[] = $char2 = $str[$i + 1];
            }
            
            if ($charset == MPC_FROM_CHARSET_UTF8 && isset($str[$i + 2])) {
                $binarys[] = $char3 = $str[$i + 2];
            }
            
            if ($this->isPictogram($binarys)) {
                $i += $plus;
            } elseif ((($char1 >= 0x81 && $char1 <= 0x9F) || ($char1 >= 0xE0 && $char1 <= 0xFC)) && $charset == MPC_FROM_CHARSET_SJIS) {
                $buf .= pack('C*', $char1, $char2);
                $i++;
            } else {
                $buf .= pack('C', $char1);
            }
        }
        return $buf;
    }
    
    /**
    * i-modeG܂܂Ă邩`FbN
    *
    * @return integer
    */
    function Count()
    {
        $count   = 0;
        $buf     = '';
        $str     = $this->getString();
        $type    = $this->getStringType();
        $charset = $this->getFromCharset();
        $plus    = ($charset == MPC_FROM_CHARSET_UTF8) ? 2 : 1;
        
        if ($type != MPC_FROM_OPTION_RAW) {
            if ($type == MPC_FROM_OPTION_WEB) {
                $count = preg_match_all('/&#x([a-z0-9]{4});/i', $str, $r);
            }
            $regex = str_replace('{PATH}', preg_quote(rtrim($this->getFOMAImagePath(), '/'), '/'), $this->getRegex($type));
            $count += preg_match_all($regex, $str, $r);
        }
        
        $str = unpack('C*', $str);
        for ($i = 1;$i <= count($str);$i++) {
            $binarys = array();
            $binarys[] = $char1 = $str[$i];
            if (isset($str[$i + 1])) {
                $binarys[] = $char2 = $str[$i + 1];
            }
            
            if ($charset == MPC_FROM_CHARSET_UTF8 && isset($str[$i + 2])) {
                $binarys[] = $char3 = $str[$i + 2];
            }
            
            if ($this->isPictogram($binarys)) {
                $count++;
                $i += $plus;
            } elseif ((($char1 >= 0x81 && $char1 <= 0x9F) || ($char1 >= 0xE0 && $char1 <= 0xFC)) && $charset == MPC_FROM_CHARSET_SJIS) {
                $i++;
            }
        }
        return $count;
    }
    
    /**
    * oCii-modeGǂA`FbN
    * 
    * @param array $chars
    * @return boolean
    */
    function isPictogram($chars)
    {
        if ($this->getFromCharset() == MPC_FROM_CHARSET_UTF8) {
            if (count($chars) != 3){
                return false;
            }
            list($char1, $char2, $char3) = $chars;
            if ($char1 == 0xEE &&
                    (
                        ($char2 == 0x98 && ($char3 >= 0xBE && $char3 <= 0xBF)) ||
                        ($char2 == 0x99 && ($char3 >= 0x80 && $char3 <= 0xBF)) ||
                        ($char2 == 0x9A && ($char3 >= 0x80 && $char3 <= 0xBA)) ||
                        ($char2 == 0x9B && ($char3 >= 0x8E && $char3 <= 0xBF)) ||
                        ($char2 == 0x9C && ($char3 >= 0x80 && $char3 <= 0xBF)) ||
                        ($char2 == 0x9D && ($char3 >= 0x80 && $char3 <= 0x97))
                    )
            ) {
                $boolean = true;
            } else {
                $boolean = false;
            }
        } else {
            if (count($chars) != 2) {
                return false;
            }
            list($char1, $char2) = $chars;
            if ((($char1 == 0xF8) && ($char2 >= 0x9F) && ($char2 <= 0xFC)) || (($char1 == 0xF9) && (($char2 >= 0x40 && $char2 <= 0x4F) || ($char2 >= 0x50 && $char2 <= 0x7E) || ($char2 >= 0x80 && $char2 <= 0xFC)))) {
                $boolean = true;
            } else {
                $boolean = false;
            }
        }
        return $boolean;
    }
}
// }}}
?>