<?php
require_once 'common.php';

// {{{ class MPC_SoftBank
/**
* SoftBankGϊx[XNX
* 
* @author   ryster <ryster@php-develop.org>
* @license  http://www.opensource.org/licenses/lgpl-license.php The LGPL License
* @link     http://php-develop.org/MobilePictogramConverter/
*/
class MPC_SoftBank extends MPC_Common
{
  /**
  * GoK\
  * @var string
  */
    var $regex = array(
        'WEB' => '/[\x1B][\x24](([\x47][\x21-\x7A]+)|([\x45][\x21-7A]+)|([\x46][\x21-\x7A]+)|([\x4F][\x21-\x6D]+)|([\x50][\x21-\x6C]+)|([\x51][\x21-\x5E]+))[\x0F]?/',
        'IMG' => '/<img src="{PATH}\/((17|18|20)\d{3})\.gif" alt="" border="0" width="15" height="15" \/>/ie',
    );
    
    /**
    * RAW => WEB ϊe[u
    * @var array
    */
    var $sr2sw_table = array(
        0x80 => 0x47, 0x81 => 0x47, 0x84 => 0x45,
        0x85 => 0x46, 0x88 => 0x46, 0x89 => 0x46,
        0x8C => 0x4F, 0x8D => 0x4F, 0x90 => 0x50,
        0x91 => 0x50, 0x94 => 0x51
    );
    
    /**
    * 񂩂SoftBankGoAw肳ꂽtH[}bgɕϊ
    * 
    * @param string  $to     (MPC_TO_FOMA, MPC_TO_EZWEB, MPC_TO_SOFTBANK)
    * @param integer $option (MPC_TO_OPTION_RAW, MPC_TO_OPTION_WEB, MPC_TO_OPTION_IMG)
    * @return string
    */
    function Convert($to, $option = MPC_TO_OPTION_RAW)
    {
        $buf = $buf2 = '';
        $this->setTo($to);
        $this->setOption($option);
        $str     = $this->getString();
        $type    = $this->getStringType();
        $charset = $this->getFromCharset();
        $plus    = ($charset == MPC_FROM_CHARSET_UTF8) ? 2 : 1;
        
        if ($type != MPC_FROM_OPTION_RAW && $type != MPC_FROM_OPTION_WEB) {
            $regex = str_replace('{PATH}', preg_quote(rtrim($this->getSoftBankImagePath(), '/'), '/'), $this->getRegex($type));
            $str   = preg_replace($regex, 'pack("H*", "1B24".dechex($1)."0F")', $str);
        }
        
        $str = unpack('C*', $str);
        for ($i = 1;$i <= count($str);$i++) {
            $binarys = array();
            $binarys[] = $char1 = $str[$i];
            if (isset($str[$i + 1])) {
                $binarys[] = $char2 = $str[$i + 1];
            }
            
            if ($charset == MPC_FROM_CHARSET_UTF8 && isset($str[$i + 2])) {
                $binarys[] = $char3 = $str[$i + 2];
            }
            
            if ($this->isPictogram($binarys)) {
                if ($charset == MPC_FROM_CHARSET_SJIS) {
                    list($char1, $char2, $char3) = $this->sjis2utf8($char1, $char2);
                }
                $num  = ($char2 == 0x80 || $char2 == 0x84 || $char2 == 0x88 || $char2 == 0x8C || $char2 == 0x90 || $char2 == 0x94) ? $char3 - 0x81 : $char3 - 0x80 + 63;
                $dec1 = $this->sr2sw_table[$char2];
                $dec2 = $num + 0x21;
                $buf .= $this->encoder(hexdec($this->decs2hex(array($dec1, $dec2))));
                $i += $plus;
            } elseif ((($char1 >= 0x81 && $char1 <= 0x9F) || ($char1 >= 0xE0 && $char1 <= 0xFC)) && $charset == MPC_FROM_CHARSET_SJIS) {
                $buf .=  pack('C*', $char1, $char2);
                $i++;
            } else {
                $buf .= pack('C', $char1);
            }
        }
        
        preg_match_all($this->getRegex('WEB'), $buf, $matches);
        if (count($matches) > 0) {
            $split = preg_split($this->getRegex('WEB'), $buf);
            $max  = count($split) - 1;
            foreach ($split as $key => $value) {
                if ($max != $key) {
                    $emoji = '';
                    $decs = unpack('C*', $matches[1][$key]);
                    $num  = count($decs);
                    for ($i = 2;$i <= $num;$i++) {
                        $dec    = hexdec(dechex($decs[1]).dechex($decs[$i]));
                        $emoji .= $this->encoder($dec);
                    }
                    $buf2 .= $value.$emoji;
                } else {
                    $buf2 .= $value;
                }
            }
            $buf = $buf2;
        }
        
        return $buf;
    }
    
    /**
    * 񂩂SoftBankGO
    * 
    * @return string
    */
    function Except()
    {
        $buf = $buf2 = '';
        $str     = $this->getString();
        $type    = $this->getStringType();
        $charset = $this->getFromCharset();
        $plus    = ($charset == MPC_FROM_CHARSET_UTF8) ? 2 : 1;
        
        if ($type != MPC_FROM_OPTION_RAW && $type != MPC_FROM_OPTION_WEB) {
            $regex = str_replace('{PATH}', preg_quote(rtrim($this->getSoftBankImagePath(), '/'), '/'), $this->getRegex($type));
            return preg_replace($regex, '', $str);
        }
        
        $str = unpack('C*', $str);
        for ($i = 1;$i <= count($str);$i++) {
            $binarys = array();
            $binarys[] = $char1 = $str[$i];
            if (isset($str[$i + 1])) {
                $binarys[] = $char2 = $str[$i + 1];
            }
            
            if ($charset == MPC_FROM_CHARSET_UTF8 && isset($str[$i + 2])) {
                $binarys[] = $char3 = $str[$i + 2];
            }
            
            if ($this->isPictogram($binarys)) {
                $i += $plus;
            } elseif ((($char1 >= 0x81 && $char1 <= 0x9F) || ($char1 >= 0xE0 && $char1 <= 0xFC)) && $charset == MPC_FROM_CHARSET_SJIS) {
                $buf .= pack('C*', $char1, $char2);
                $i++;
            } else {
                $buf .= pack('C', $char1);
            }
        }
        
        $buf = preg_replace($this->getRegex('WEB'), '', $buf);
        return $buf;
    }
    
    /**
    * SoftBankG܂܂Ă邩`FbN
    *
    * @return integer
    */
    function Count()
    {
        $count   = 0;
        $buf     = '';
        $str     = $this->getString();
        $type    = $this->getStringType();
        $charset = $this->getFromCharset();
        $plus    = ($charset == MPC_FROM_CHARSET_UTF8) ? 2 : 1;
        
        if ($type != MPC_FROM_OPTION_RAW && $type != MPC_FROM_OPTION_WEB) {
            $regex = str_replace('{PATH}', preg_quote(rtrim($this->getSoftBankImagePath(), '/'), '/'), $this->getRegex($type));
            return preg_match_all($regex, $str, $r);
        }
        
        $str = unpack('C*', $str);
        for ($i = 1;$i <= count($str);$i++) {
            $binarys = array();
            $binarys[] = $char1 = $str[$i];
            if (isset($str[$i + 1])) {
                $binarys[] = $char2 = $str[$i + 1];
            }
            
            if ($charset == MPC_FROM_CHARSET_UTF8 && isset($str[$i + 2])) {
                $binarys[] = $char3 = $str[$i + 2];
            }
            
            if ($this->isPictogram($binarys)) {
                $count++;
                $i += $plus;
            } elseif ((($char1 >= 0x81 && $char1 <= 0x9F) || ($char1 >= 0xE0 && $char1 <= 0xFC)) && $charset == MPC_FROM_CHARSET_SJIS) {
                $buf .= pack('C*', $char1, $char2);
                $i++;
            } else {
                $buf .= pack('C', $char1);
            }
        }
        
        $count += preg_match_all($this->getRegex('WEB'), $buf, $r);
        return $count;
    }
    
    /**
    * oCiSoftBankGǂA`FbN
    * 
    * @param  array $chars
    * @return boolean
    */
    function isPictogram($chars)
    {
        if ($this->getFromCharset() == 'UTF-8') {
            if (count($chars) != 3){
                return false;
            }
            list($char1, $char2, $char3) = $chars;
            if (($char1 == 0xEE && 
                //G1i{j
                (($char2 == 0x80 && ($char3 >= 0x81 && $char3 <= 0xBF)) ||
                 ($char2 == 0x81 && ($char3 >= 0x80 && $char3 <= 0x9A)) ||
                 //G2i{j
                 ($char2 == 0x84 && ($char3 >= 0x81 && $char3 <= 0xBF)) ||
                 ($char2 == 0x85 && ($char3 >= 0x80 && $char3 <= 0x9A)) ||
                 //G3i{j
                 ($char2 == 0x88 && ($char3 >= 0x81 && $char3 <= 0xBF)) ||
                 ($char2 == 0x89 && ($char3 >= 0x80 && $char3 <= 0x93)) ||
                 //G4igj
                 ($char2 == 0x8C && ($char3 >= 0x81 && $char3 <= 0xBF)) ||
                 ($char2 == 0x8D && ($char3 >= 0x80 && $char3 <= 0x8D)) ||
                 //G5igj
                 ($char2 == 0x90 && ($char3 >= 0x81 && $char3 <= 0xBF)) ||
                 ($char2 == 0x91 && ($char3 >= 0x80 && $char3 <= 0x8C)) ||
                 //G6igj
                 ($char2 == 0x94 && ($char3 >= 0x81 && $char3 <= 0xBE)))))
            {
                $boolean = true;
            } else {
                $boolean = false;
            }
        } else {
            if (count($chars) != 2){
                return false;
            }
            list($char1, $char2) = $chars;
            if (
                //G1({)
                ($char1 == 0xF9 && (($char2 >= 0x41 && $char2 <= 0x7E) || ($char2 >= 0x80 && $char2 <= 0x9B))) ||
                //G2i{j
                ($char1 == 0xF7 && (($char2 >= 0x41 && $char2 <= 0x7E) || ($char2 >= 0x80 && $char2 <= 0x9B))) ||
                //G3({)
                ($char1 == 0xF7 && ($char2 >= 0xA1 && $char2 <= 0xF3)) ||
                //G4(g)
                ($char1 == 0xF9 && ($char2 >= 0xA1 && $char2 <= 0xED)) ||
                //G5(g)
                ($char1 == 0xFB && (($char2 >= 0x41 && $char2 <= 0x7E) || ($char2 >= 0x80 && $char2 <= 0x8D))) ||
                //G6(g)
                ($char1 == 0xFB && ($char2 >= 0xA1 && $char2 <= 0xD7))
            ) {
                $boolean = true;
            } else {
                $boolean = false;
            }
        }
        return $boolean;
    }
    
    /**
    * SJIS(dec)UTF-8(dec)֕ϊ
    *
    * @access private
    * @param  integer $char1
    * @param  integer $char2
    * @return array
    */
    function sjis2utf8($char1, $char2)
    {
        if ($char1 == 0xF9 && ($char2 >= 0x41 && $char2 <= 0x7E)) {
            $diff = 6464;
        } elseif ($char1 == 0xF9 && ($char2 >= 0x80 && $char2 <= 0x9B)) {
            $diff = 6465;
        } elseif ($char1 == 0xF7 && ($char2 >= 0x41 && $char2 <= 0x7E)) {
            $diff = 5696;
        } elseif ($char1 == 0xF7 && ($char2 >= 0x80 && $char2 <= 0x9B)) {
            $diff = 5697;
        } elseif ($char1 == 0xF7 && ($char2 >= 0xA1 && $char2 <= 0xF3)) {
            $diff = 5536;
        } elseif ($char1 == 0xF9 && ($char2 >= 0xA1 && $char2 <= 0xED)) {
            $diff = 5792;
        } elseif ($char1 == 0xFB && ($char2 >= 0x41 && $char2 <= 0x7E)) {
            $diff = 5952;
        } elseif ($char1 == 0xFB && ($char2 >= 0x80 && $char2 <= 0x8D)) {
            $diff = 5953;
        } else {
            $diff = 5792;
        }
        
        $decs = unpack('C*', mb_convert_encoding(pack('H*', dechex((hexdec($this->decs2hex(array($char1, $char2))) - $diff))), 'UTF-8', 'unicode'));
        return array($decs[1], $decs[2], $decs[3]);
    }
}
// }}}
?>