<?php
/* ---------------------------------------------
 * http://blog.asial.co.jp/332
 * http://ke-tai.org/blog/2008/01/22/ketaigmap/
 * --------------------------------------------- */
//携帯でGoogleMapの画像をプリントするクラス
class GoogleMobileMapView {
	//取得URLとクエリを保持する変数
	var $geturl = 'http://maps.google.com/mapprint?tstyp=4';
	var $query = "";
	var $image_format = "1";
	var $type = array("1"=>"gif", "2"=>"png", "3"=>"jpeg");

	//画像を取得するためのURLをセットするメソッド
	function setUrl($latitude,$longitude,$settings,$points = null) {
		//中心の位置がない場合はfalseを返す
		if ($latitude == "" || $longitude == "") {
			return false;
		}

		//画像を取得するためのパラメータをセットしていく
		$this->query = $this->geturl . "&c=$longitude,$latitude";
		if (!isset($settings["w"])) { $settings["w"] = 200; }
		if (!isset($settings["h"])) { $settings["h"] = 200; }
		if (!isset($settings["z"])) { $settings["z"] = 0; }
		$this->query .= "&r={$settings["w"]},{$settings["h"]}";
		$this->query .= "&z={$settings["z"]}";

		//出力形式をセット（デフォルトはGIF
		if (isset($settings["image_format"])) { $this->image_format = $settings["image_format"]; }
		$this->query .= "&image_format=" . $this->image_format;

		//複数のポイントを表示するのにも対応させる
		if (!is_array($points)) { return true; }
		foreach ($points as $point) {
			if (!isset($point["latitude"]) || !isset($point["longitude"])) { continue; }
			if (!isset($point["iconid"]) ) { $point["iconid"] = 15; }
			$this->query .= "&l={$point["longitude"]},{$point["latitude"]},{$point["iconid"]}";
		}
		return true;
	}

	//画像を出力するメソッド
/*
	function viewPicture() {
		$pic_type = $this->image_format;
		header("Content-type: image/" . $this->type[$pic_type]);
		if ($this->query != "") {
			readfile($this->query);
		}
	}
*/
	function viewPicture() {
		$pic_type = $this->image_format;
		if ($this->query != "") {
			//return readfile($this->query);
			return $this->query;
		}
	}
}
?>
